import java.awt.Window.Type;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.lang.reflect.Field;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.ParameterizedType;



public class Main {
	
	//main from slide 8 (Encapsulation)
	/*
	public static void main(String args[]){
		SteveMartinHumanAutomaton ageLess = new SteveMartinHumanAutomaton();
		ageLess.setAge(67);
		ageLess.displayAppearence();
	
	}
	*/
	
	//main from slide 15 (Reflection)
	/*
	public static void main(String args[]) {
		Employee e[] = new Employee[] { new Employee("Billy Bob"), new Manager("Rick Roll")};
		System.out.println("The name of the employee e is " + e[0].getName());
		Class cl0 = e[0].getClass();
		System.out.println("The name of the class of e[0] is " + cl0.getName());
		System.out.println("The name of the employee e is " + e[1].getName());
		Class cl1 = e[1].getClass();
		System.out.println("The name of the class of e[1] is " + cl1.getName());						
	}
	*/
	
	
	//main from slide 19 (Reflection, Employee, Fields)
	
	/*
	public static void main (String args[]) throws NoSuchFieldException, SecurityException{
		Field field[] = Employee.class.getDeclaredFields();
		int i = 0;
		while(i < field.length) {
			System.out.println("Employee contains the field " + field[i].getName() + " which is a/an " + field[i].getType());
			i++;
		}
	}
	*/
	
	//main from slide 21(Reflection, field, field parameters)
	/*
	public static void main (String args[]) throws NoSuchFieldException, SecurityException{
		Field idField = Employee.class.getDeclaredField("id");
		ParameterizedType params = (ParameterizedType)idField.getGenericType();
		java.lang.reflect.Type[] paramsType = params.getActualTypeArguments();
		int i = 0;
		while (i < paramsType.length){
			System.out.println("The type of the first parameter is " + paramsType[i].toString());
			i++;
		}
	}
	*/
	
	
	
	//main from slide 25 (Reflection, field, change private variable)
	/*
	public static void main (String args[]) throws NoSuchFieldException, SecurityException, IllegalArgumentException, IllegalAccessException{
		MrConstant mrConstant = new MrConstant();
		mrConstant.printName();
		Field field = mrConstant.getClass().getDeclaredField("name");
		field.setAccessible(true);
		field.set(mrConstant, "NotSoMuch");
		mrConstant.printName();
	}
	*/
	 

	//main from slide 28, guessing the password to moria
	/*
	public static void main(String args[]) {
		HiddenMethods hm = new HiddenMethods();
		while (!hm.getAnswerFlag()) {
			hm.askPassword();
			try {
				BufferedReader bufferRead = new BufferedReader(
				new InputStreamReader(System.in));
				String guess = bufferRead.readLine();
				hm.validatePassword(guess);
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}
	*/
	
	//main from slide 30, Reflection, method
	/*
	public static void main(String args[]){
		//Get the Class object associated with this class.
		HiddenMethods hm = new HiddenMethods();
		Class objClass = hm.getClass();
		
		//Get all of the public methods associated with this class.
		Method[] publicMethods = objClass.getMethods();
		for(Method publicMethod: publicMethods)
			System.out.println("Public method found: " + publicMethod.toString());
	
		//Get the all methods associated with this class.
		Method[] allMethods = objClass.getDeclaredMethods();
		for(Method method: allMethods)
			System.out.println("Public method found: " + method.toString());
	}
	*/
	
	//main from slide 33, Reflection, method, invoking privae method
	/*
	public static void main(String args[]) throws NoSuchMethodException, SecurityException, IllegalAccessException, IllegalArgumentException, InvocationTargetException{
		HiddenMethods hm = new HiddenMethods();
		Class<? extends HiddenMethods> objClass = hm.getClass();
		Method setPasswordMethod = objClass.getDeclaredMethod("setPassword", String.class);
		setPasswordMethod.setAccessible(true);
		setPasswordMethod.invoke(hm, "blah");
		hm.validatePassword("blah");
	}
	*/
	
}
